	device zxspectrum128
        ORG #6000
begin
st:incbin "sintable.data"
runi:
	ld sp,$5FE0
;prepare texture
	ld a,$10,bc,$7ffd:out (c),a
	ld hl,song:call INIT

;black screen
    ld hl,$5AFF,de,$5AFE,bc,$1B00-1,(hl),0:lddr

;	ld hl,$C000
;tx:
;	ld d,st/256
;	ld e,l
;	srl e
;	ld a,(de)
;	ld c,a
;	ld a,h
;	and 63
;	ld e,a
;	srl e
;	ld a,(de)
;	add a,c
;	ld e,a
;	ld a,(de)
;	and 7
;;	add a,a
;;	add a,a
;;	add a,a
;	ld (hl),a
;	inc l
;	jr nz,tx
;	inc h
;	jr nz,tx

;draw grid
	ld hl,$4000
dg1:
	ld a,h
	rra
	sbc a,a
	xor $aa
dg2:
	ld (hl),a
	inc l
	jr nz,dg2
	inc h
	ld a,h
	cp $58
	jr nz,dg1
;	ld a,h
;	add a,a
;	ld c,a
;	ld a,l
;	add a,l
;	and c
;	and 7
;	add a,a
;	add a,a
;	add a,a
;	ld (hl),a
;	inc l
;	jr nz,tx
;	inc h
;	jr nz,tx

;copy smile

	ld de,sm
	ld h,$C0
cs1:
	ld l,0
cs2:
	ld a,(de)
	inc de
	and 7
	ld (hl),a
;	inc h
;	ld (hl),a
;	inc l
;	ld (hl),a
;	dec h
;	ld (hl),a
	inc l
;	ld a,l
;	cp 32
	bit 5,l
	jr z,cs2
	inc h
	ld a,h
	cp $D0
	jr nz,cs1

	ld h,$C0
cs3:
	ld l,0
	ld e,32
	push hl
	ld d,h
	ld bc,256-32
	ldir
	pop hl
	inc h
	jr nz,cs3
	ld hl,$C000
	ld de,$D000
	ld bc,$2FFF+1
	ldir
mm:
	ei
	halt
bo1:	ld a,7:out ($FE),a
an1: ld a,-1
	inc a
	ld (an1+1),a
; zx.w = sin_table(an)
	ld h,st/256
	ld l,a
	ld e,(hl)
	inc h
	ld d,(hl)
	ld (zx),de
; zy.w = cos_table(an)
	ld a,l
	add a,64
	ld l,a
	ld d,(hl)
	dec h
	ld e,(hl)
	ld (zy),de

;{ centrowanie }
;height=32
;width=24
; fx_.w = -((height/2)*(zx+zy))
	ld hl,(zx)
	ld de,(zy)
	add hl,de
;*16
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,h:cpl:ld h,a
	ld a,l:cpl:ld l,a
	inc hl
;	ld bc,60:add hl,bc
	ld (fx_),hl
; fy_.w = -((width/2)*(zx-zy))
 	ld hl,(zx)
 	ld de,(zy)
 	or a
 	sbc hl,de
;*12
	ld de,hl
	add hl,hl
	add hl,de;*3
	add hl,hl
	add hl,hl

;	ld bc,32:add hl,bc
	ld (fy_),hl

;	ld bc,$5800
; bw=8;+12
; StartDrawing(ScreenOutput())
;  For j = 0 To height-1
	ld (back_sp+1),sp
	ld sp,$5B00
	ld a,24
rzlp:
	exa
;  fx.w = fx_
;  fy.w = fy_
	ld hl,(fx_)
	ld de,(zx)
	exx
	ld hl,(fy_)
	ld de,(zy)
	ld a,d:cpl:ld d,a
	ld a,e:cpl:ld e,a
	inc de
	exx

 dup 16
;  For i = 0 To width-1
;    ;pixels[i,j] = texture[(fx >> 8) mod 64 , (fy >> 8) mod 64]
;    ;c.a=(fx!fy)>>8
;    c.l=tt((fx>>8)&31,(fy>>8)&31)
;    Box(j*bw,i*bw,bw,bw,c);RGB(c,c,c))
;   fx = fx+zx
	add hl,de
	ld a,h
	exx
	ld c,a
	ld a,h
;	and 63
	or $C0
	ld b,a
	ld a,(bc)
;   fy = fy-zy
	add hl,de
	exx
	ld b,a

	add hl,de
	ld a,h
	exx
	ld c,a
	ld a,h
;	and 63
	or $C0
	ld b,a
	ld a,(bc)
;   fy = fy-zy
	add hl,de
	exx
	ld c,a
	push bc
; Next i
edup

;  fx_ = fx_+zy
	ld hl,(fx_)
	ld de,(zy)
	add hl,de
	ld (fx_),hl
;  fy_ = fy_+zx
	ld hl,(fy_)
	ld de,(zx)
	add hl,de
	ld (fy_),hl
	
	exa
	dec a
	jp nz,rzlp
;Next j
back_sp:ld sp,0
bo2:	ld a,2:out ($FE),a
	call PLAY
bo3:	ld a,0:out ($FE),a
;test for space
	xor a
	ld (bo1+1),a
	ld (bo2+1),a
	ld (bo3+1),a
	ld a,$7F
	in a,($FE)
	rra
	jr c,exbrd
	ld a,7,(bo1+1),a
	ld a,2,(bo2+1),a
	ld a,0,(bo3+1),a
exbrd:
	jp mm

;brd:
;	jr $
;	push af
;	ld a,$7F
;	in a,($FE)
;	rra
;	jr c,exbrd
;	pop af
;	out (c),a
;	push af
;exbrd:
;	pop af
;	ret
	
song:
 incbin "000_00018380.pt3"
plyr:
 include "PTxPlay.a80"
zx: dw 0
zy: dw 0
fx_:dw 0
fy_:dw 0

sm:incbin "smile1.bin"

end
	display end
	display /d,end-begin
	savesna "!void.sna",runi;begin

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 sectors begin,end
 call #3d13
 jp runi


 db "yo"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "rotoz.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "dust.trd","demo.C",begin,end-begin

;-----------------------------------------------------------
